{$APPTYPE CONSOLE}
{$R+}

uses
  SysUtils;

procedure Err(e: Integer; m: string; par: array of const);
begin
  Write(Format(m, par));
  Halt(e);
end;

var
  fin, fout, fans: TextFile;
  i, j, N, M, Ra, Ro, t: Integer;
  link: array of array of Integer;
  have: array of Boolean;

begin
  AssignFile(fin, ParamStr(1)); Reset(fin);
  AssignFile(fout, ParamStr(2)); Reset(fout);
  AssignFile(fans, ParamStr(3)); Reset(fans);

  Read(fin, N, M);
  SetLength(link, N);
  for i := 0 to N - 1 do begin
    Read(fin, Ro);
    SetLength(link[i], Ro);
    for j := 0 to Ro - 1 do
      Read(fin, link[i, j]);
  end;
  CloseFile(fin);

  SetLength(have, N);
  for i := 0 to N - 1 do
    have[i] := false;

  Ro := 0;
  try
    Read(fout, Ro);
    for i := 0 to Ro - 1 do begin
      Read(fout, t);
      if (t < 1) or (t > N) then Err(1, 'Bad number: %d', [t]);
      for j := 0 to High(link[t - 1]) do
        if not have[link[t - 1, j] - 1] then
          Err(1, 'Coming to %d without spravka from %d', [t, link[t - 1, j]]);
      have[t - 1] := true;
    end;
  except on E: EInOutError do
    Err(2, E.Message, []);
  end;
  Read(fans, Ra);

  if not have[M - 1] then begin
    if (Ra > 0) then Err(1, 'Could not get spravka from %d', [M])
    else Halt(0);
  end;
  if Ra < Ro then
    Err(1, 'Got %d spravkas instead of %d', [Ro, Ra])
  else if Ra > Ro then
    Err(3, 'OUCH! Got %d spravkas instead of %d', [Ro, Ra]);

  CloseFile(fout);
  CloseFile(fans);
end.