{$apptype console}

// O(n^3)

uses
  Types, Math;

var
  m, n: integer;
  sv: array of TIntegerDynArray;
  bestK: integer;
  bestPrior: TIntegerDynArray;

  
procedure bfs;
var
  qc, qh, qt: integer;
  queue, prior: TIntegerDynArray;
  docs: array of TBooleanDynArray;
  i: integer;

  function canGo: boolean;
  var
    j, v: integer;
  begin
    for j := 0 to High(sv[i]) do begin
      v := sv[i, j];
      if
        (prior[v] = -2) or (queue[qh] = -1) or (not docs[queue[qh], v])
      then begin
        Result := false;
        Exit;
      end;
    end;
    Result := true;
  end;

var
  j, k: integer;
begin
  SetLength(queue, n + 1);
  SetLength(prior, n);
  for i := 0 to n - 1 do
    prior[i] := -2;
  SetLength(docs, n);
  qc := 1;
  qh := 0;
  qt := 0;
  queue[0] := -1;
  while qc > 0 do begin
    for i := 0 to n - 1 do begin
      if (prior[i] = -2) and canGo then begin
        Inc(qc);
        qt := (qt + 1) mod (n + 1);
        queue[qt] := i;
        prior[i] := queue[qh];
        if (queue[qh] = -1) then begin
          SetLength(docs[i], n);
          FillChar(docs[i, 0], SizeOf(docs[i, 0]) * n, false);
        end
        else
          docs[i] := Copy(docs[queue[qh]]);
        docs[i, i] := true;

        if (i = m) then begin
          k := 0;
          for j := 0 to n - 1 do
            if docs[i, j] then
              Inc(k);
          if k < bestK then begin
            bestK := k;
            bestPrior := Copy(prior);
          end;
        end;
      end;
    end;
    Dec(qc);
    qh := (qh + 1) mod (n + 1);
  end;
end;


var
  fi, fo: textfile;
  i, t, j: integer;
  route: TIntegerDynArray;
begin
  AssignFile(fi, 'input.txt');
  Reset(fi);
  AssignFile(fo, 'output.txt');
  Rewrite(fo);

  Read(fi, n, m);
  Assert(InRange(n, 1, 100));
  Assert(InRange(m, 1, n));
  Dec(m);

  SetLength(sv, n);
  for i := 0 to n - 1 do begin
    Read(fi, t);
    Assert(InRange(t, 0, n - 1));
    SetLength(sv[i], t);
    for j := 0 to t - 1 do begin
      Read(fi, sv[i, j]);
      Dec(sv[i, j]);
      Assert(sv[i, j] <> i);
    end;
  end;

  bestK := MaxInt;
  bfs;

  if bestK = MaxInt then
    Write(fo, 0)
  else begin
    Write(fo, bestK);
    SetLength(route, bestK);
    t := m;
    i := bestK - 1;
    while (i >= 0) do begin
      route[i] := t;
      t := bestPrior[t];
      Dec(i);
    end;
    for i := 0 to bestK - 1 do
      Write(fo, ' ', route[i] + 1);
  end;

  CloseFile(fo);
  CloseFile(fi);
end.
