{$apptype console}

// O(n^3)

uses
  Types, Math;

var
  m, n: integer;
  sv: array of TIntegerDynArray;
  bestK: integer;
  bestPrior: TIntegerDynArray;

  
procedure bfs;
var
  queue, prior, depth: TIntegerDynArray;
  qc, qt, qh: integer;

  function canGo(ACur, ATo: integer): boolean;
  var
    i, v: integer;
  begin
    for i := 0 to High(sv[ATo]) do begin
      v := sv[ATo, i];
      if (prior[v] = -2) or (ACur = -1) or (depth[v] > depth[ACur]) then begin
        Result := false;
        Exit;
      end;
    end;
    Result := true;
  end;

var
  i: integer;
begin
  SetLength(prior, n);
  SetLength(depth, n);
  for i := 0 to n - 1 do begin
    prior[i] := -2;
    depth[i] := 0;
  end;
  SetLength(queue, n + 1);
  queue[0] := -1;
  qc := 1;
  qh := 0;
  qt := 0;
  while qc > 0 do begin
    for i := 0 to n - 1 do
      if (prior[i] = -2) and canGo(queue[qh], i) then begin
        Inc(qc);
        qt := (qt + 1) mod (n + 1);
        queue[qt] := i;
        prior[i] := queue[qh];
        if (queue[qh] <> -1) then
          depth[i] := depth[queue[qh]];
        Inc(depth[i]);

        if (i = m) then begin
          if depth[m] < bestK then begin
            bestK := depth[m];
            bestPrior := Copy(prior);
          end;
          Exit;
        end;
      end;
    Dec(qc);
    qh := (qh + 1) mod (n + 1);
  end;
end;


var
  fi, fo: textfile;
  i, t, j: integer;
  route: TIntegerDynArray;
begin
  AssignFile(fi, 'input.txt');
  Reset(fi);
  AssignFile(fo, 'output.txt');
  Rewrite(fo);

  Read(fi, n, m);
  Assert(InRange(n, 1, 100));
  Assert(InRange(m, 1, n));
  Dec(m);

  SetLength(sv, n);
  for i := 0 to n - 1 do begin
    Read(fi, t);
    Assert(InRange(t, 0, n - 1));
    SetLength(sv[i], t);
    for j := 0 to t - 1 do begin
      Read(fi, sv[i, j]);
      Dec(sv[i, j]);
      Assert(sv[i, j] <> i);
    end;
  end;

  bestK := MaxInt;
  bfs;

  if bestK = MaxInt then
    Write(fo, 0)
  else begin
    Write(fo, bestK);
    SetLength(route, bestK);
    t := m;
    i := bestK - 1;
    while (i >= 0) do begin
      route[i] := t;
      t := bestPrior[t];
      Dec(i);
    end;
    for i := 0 to bestK - 1 do
      Write(fo, ' ', route[i] + 1);
  end;

  CloseFile(fo);
  CloseFile(fi);
end.
